// JavaScript Document

var prefsFile; // The preferences file
var prefsXML; // The XML data
var stream; // The FileStream object used to read and write prefsFile data.
var poplingPrefs; //global var for enire app
var firstRun = false;

/**
* Called when the application is first rendered, and when the user clicks the Save button.
* If the preferences file *does* exist (the application has been run previously), the method 
* sets up a FileStream object and reads the XML data, and once the data is read it is processed. 
* If the file does not exist, the method calls the setPrefs() method which creates the file. 
*/


function getParsedPrefs(){
	trace(getParsedPrefs);
	return poplingPrefs;
}



function getPrefs(){
	trace("getPrefs - prefs.js");
	
	prefsFile = air.File.applicationStorageDirectory;
	prefsFile = prefsFile.resolvePath("preferences.xml"); 
	stream = new air.FileStream();
	
	if (prefsFile.exists) {
		trace("prefs exist, getting");
		stream.open(prefsFile, air.FileMode.READ);
		prefsXML = stream.readUTFBytes(stream.bytesAvailable);
		stream.close();
		poplingPrefs = parsePrefsXML(prefsXML);
		poplingPrefs['firstRun'] = false;
		return poplingPrefs;
	}else{
		trace("prefs don't exist, this is first run");
		var prefsXML = createInitialPrefs();
		poplingPrefs = parsePrefsXML(prefsXML);
		return poplingPrefs;
	}
}


function createInitialPrefs(){
	trace("createInitialPrefs");
	
	var prefsArray = new Array();
	
	prefsArray['name'] = '';
	prefsArray['password'] = null;
	prefsArray['popTime'] = 5;
	prefsArray['teaser'] = "true";
	prefsArray['skipCloseDialog'] = 0;
	prefsArray['style'] = 'popling_style';
	
	//window postion
	if(air.NativeApplication.supportsDockIcon == true){
		trace("createInitialPrefs - client is mac");
		wp = 3;//top,right,bottom,left
	}else{
		trace("createInitialPrefs - client is PC");
		wp = 0;//top,right,bottom,left
	}
	prefsArray['notifyPos'] = wp;

	
	var prefsXML = setPrefs(prefsArray);
	return prefsXML;

}

function zapPrefs(){
	prefsFile = air.File.applicationStorageDirectory;
	prefsFile = prefsFile.resolvePath("preferences.xml"); 
	prefsFile.deleteFile(); 
	
	trace("prefs ZAPPED, redirecting to root");
	cleanUp();
	window.location.reload();
}

/**
* Called after the data from the prefs file has been read. The readUTFBytes() reads
* the data as UTF-8 text, and the XML() function converts the text to XML. The x, y,
* width, and height properties of the main window are then updated based on the XML data.
*/
function parsePrefsXML(prefsXML){
	trace("parsing prefs" + prefsXML);
	
	var pt = new Array();
	
	var domParser = new DOMParser();
	
	prefsXML = domParser.parseFromString(prefsXML, "text/xml");
	var userPrefs = prefsXML.getElementsByTagName("userPrefs")[0];
	var appPrefs = prefsXML.getElementsByTagName("appPrefs")[0];
	
	pt['name'] = userPrefs.getAttribute("name");
	pt['popTime'] = appPrefs.getAttribute("popTime");
	pt['teaser'] = appPrefs.getAttribute("teaser");
	pt['notifyPos'] = appPrefs.getAttribute("notifyPos");
	//pt['versionNotes'] = appPrefs.getAttribute("versionNotes");
	pt['skipCloseDialog'] = appPrefs.getAttribute("skipCloseDialog");
	pt['style'] = appPrefs.getAttribute("style");
	
	trace(pt['style']);
	
	if(pt['style'] == null){
			 pt['style'] = 'popling_style';
	}
	
 	trace("get skip close"+pt['skipCloseDialog']);
	return pt;
}

//////
//  Constructs XML data and saves the 
// data to the preferences.xml file.  Creates the XML object 
/////
function setPrefs(prefsArray,refreshRoot){
	trace("setPrefs :"+String(prefsArray));
	
	var un = prefsArray['name'];
	var pass = prefsArray['password'];
	var pt  = prefsArray['popTime'];
	var t  = prefsArray['teaser'];
	var np = prefsArray['notifyPos'];
	var st = prefsArray['style'];
	//var vn = prefsArray['versionNotes'];
	var cd = prefsArray['skipCloseDialog'];
	var runAtStartUp = prefsArray['runAtStartUp'];
	
	trace("style at root: "+st);
	
	
	//if not set in browser, go to default or previous setting
	if(typeof un == "undefined"){un=poplingPrefs['name'];}
	if(typeof pt == "undefined"){pt=poplingPrefs['popTime'];}
	if(typeof t  == "undefined"){t=poplingPrefs['teaser'];}
	if(typeof np == "undefined"){np=poplingPrefs['notifyPos'];}
	if(typeof st == "undefined"){st=poplingPrefs['style'];}
	//if(typeof vn == "undefined"){vn=poplingPrefs['versionNotes'];}
	if(typeof cd == "undefined"){cd=0;}
	

	if(typeof pass != "undefined" && pass != null){
		setPass(pass);
	}
	
	if(typeof runAtStartup != "undefined" && runAtStartup != null){
		setRunAtStartup(s);
	}
	
	trace("style: "+st);
	
	var cr = "";
	prefsXML =  "<?xml version='1.0' encoding='utf-8'?>" + cr
	+ "<preferences>" + cr 
	+ "    <userPrefs name='" + un + "'" + " />" + cr
	+ "    <appPrefs popTime='" + pt + "' teaser='" + t + "' notifyPos='" + np + "' skipCloseDialog='"+cd+"' style='"+st+"'/>" + cr
	+ "    <update last=''  />" + cr	
	+ "</preferences>";
	
	//versionNotes='"+vn+"'" + " ///went in <update
	
	trace("prefsXML: "+prefsXML);
	
	stream = new air.FileStream();
	stream.open(prefsFile, air.FileMode.WRITE);
	stream.writeUTFBytes(prefsXML);
	stream.close();
	
	if(refreshRoot){
		trace("prefs set, redirecting to root");
		reloadApp();
	}else{
		return prefsXML;
	}
}

function reloadApp(){
	trace("reloadApp");
	
	//getPrefs();
	initPopUI();
	
	makeFull();
	
	setWindowPosition();
	
	navToTab('cards');
	
	turnOn();


}

////
///  Password info is stored separately and encryped
//
	
function setPass(str){
	trace("setPass:" +str);
	data = new air.ByteArray();
	data.writeUTFBytes( str );
	air.EncryptedLocalStore.setItem( 'password', data );	
}


function getPass(m){
	var sv = air.EncryptedLocalStore.getItem( 'password' );
	if(sv!=null){
		sv = sv.readUTFBytes( sv.bytesAvailable );	
		return sv;
	}else{
		return '';	
	}
}

function getUser(){
	var u = poplingPrefs['name'];
	return u;
}

function setRunAtStartup(toggle){
	trace("setRunAtStartup: "+toggle);
	try {
        air.NativeApplication.nativeApplication.startAtLogin = toggle;
    } catch (error){
		$("#app_mess").val( error);
       // alert("set: "+error);
    }
}

function getRunAtStartup(){
	try {
       return air.NativeApplication.nativeApplication.startAtLogin
    } catch (error) {
		$("#app_mess").val(error);
        return false;
    }
	//return true;
}