// JavaScript Document

var urlString;
var urlReq;
var urlStream;
var fileData;
var version;
var appVersion;

if(debug){
	var poplingInstaller = 'poplingBeta.air'
}else{
	var poplingInstaller = 'popling.air'
}

//TEST FOR A NEW VERSION

function getCurrentVersion(){
	return appVersion;
}

function updateVersionViewed(appVersion){
	trace("version viewed:" +appVersion);
	data = new air.ByteArray();
	data.writeUTFBytes( appVersion );
	air.EncryptedLocalStore.setItem( 'versionViewed', data );	
}

function getVersionViewed(){
	var sv = air.EncryptedLocalStore.getItem( 'versionViewed' );
	if(sv!=null){
		sv = sv.readUTFBytes( sv.bytesAvailable );	
		return sv;
	}else{
		return '';	
	}
}

//download version JSON
function getAppVersion(){
	trace("getting version");
	//displayVersionCheckMessage();
	
	if(debug){
		 var u = remoteUrl + "air/version_beta.txt";
	}else{
	var u = remoteUrl + "air/version.txt";
	}
	
	$.ajax({
	   type: "GET",
	   url: u,
	   timeout:global_timeout,
	   success: function(data){
			var r = JSON.parse(data);
			version = r.version;
			parseVersion(version);
	   },
	   error:displayOfflineMessage

	 });		
		
}

//these functions found in messages.js
//displayVersionCheckMessage()
//displayUpgradeMessage()

function getThisVersion(){
	var xmlString = air.NativeApplication.nativeApplication.applicationDescriptor;
	var appXml = new DOMParser();
	var xmlobject = appXml.parseFromString(xmlString, "text/xml");
	var root = xmlobject.getElementsByTagName('application')[0];
	appVersion = root.getElementsByTagName("version")[0].childNodes[0].nodeValue;
	//trace("appVersion:"+ appVersion);
	return appVersion;
}

//parse version xml, compair vs. current
function parseVersion(currentVersion){
	var thisVersion = getThisVersion();
	trace("currentVersion: "+currentVersion+" runtimeVersion: "+thisVersion);
	if(currentVersion > thisVersion){
		trace("getting file to update");
		continueInitializing(true);
	}else{
		trace("no new version");
		continueInitializing(false);
	}
}

//GET THE FILE FROM THE SERVER. 
function getAirFile(){
	turnOff();
	urlString = remoteUrl + "install/" + poplingInstaller;
	trace("getting air file: "+urlString);

	urlReq = new air.URLRequest(urlString);
	urlReq.useCache = false;
	
	urlStream = new air.URLStream();
	fileData = new air.ByteArray();
	urlStream.addEventListener(air.Event.COMPLETE, loaded);
	urlStream.load(urlReq);

}

function loaded(event) {
	//update status message
	var statusMessage = "Update Downloaded";
	document.getElementById("app_mess").innerHTML = statusMessage;
    urlStream.readBytes(fileData, 0, urlStream.bytesAvailable);
    writeAirFile();
}

function writeAirFile() {
    var file = air.File.desktopDirectory.resolvePath(poplingInstaller);
    var fileStream = new air.FileStream();
    fileStream.addEventListener(air.Event.CLOSE, fileClosed);
    fileStream.openAsync(file, air.FileMode.WRITE);
    fileStream.writeBytes(fileData, 0, fileData.length);
    fileStream.close();
}

function fileClosed(event) {
	
	trace("file written");
	updateVersion();
}

//UPDATE THE AIR APPLICATION
function updateVersion(){
	trace("updating version");
	var updater = new air.Updater();
	var airFile = air.File.desktopDirectory.resolvePath(poplingInstaller);
	updater.update(airFile, version);
}
